'From Squeak2.7 of 5 January 2000 [latest update: #1762] on 3 July 2000 at 8:51:12 pm'!
Random subclass: #NormalRandom
	instanceVariableNames: 'cachedValue '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Numbers'!
!NormalRandom commentStamp: 'JMV 7/3/2000 20:21' prior: 0!
My instances are random variables with Normal distribution (mean 0 and variance 1), using the Box-Muller method!


!NormalRandom methodsFor: 'as yet unclassified' stamp: 'JMV 6/6/2000 08:42'!
next
	"Two random values are generated. So, answer one and cache the other."

	| x1 x2 t1 t2 y1 y2 |
	cachedValue notNil
		ifTrue: [
			y1 _ cachedValue.
			cachedValue _ nil.
			^ y1 ].
	x1 _ super next.
	x2 _ super next.
	t1 _ (-2 * x1 ln) sqrt.
	t2 _ 2 * Float pi	* x2.
	y1 _ t1 * t2 cos.
	y2 _ t1 * t2 sin.
	cachedValue _ y2.
	^ y1! !
